#!/bin/bash -e
# This file is part of the FUSS FUCC in-place upgrade project.
# Place this script in OctoNet in order to automatically update FUSS 9 clients
# Copyright (C) 2021-2022 The FUSS Project <info@fuss.bz.it>
# Authors: Marco Marinello <contact-nohuman@marinello.bz.it>
#          Simone Piccardi <piccardi@truelite.it>
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as
# published by the Free Software Foundation, either version 3 of the
# License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with this program.  If not, see <https://www.gnu.org/licenses/>.

if [ "$(lsb_release -sc)" == "buster" ]; then
  FUSS_SERVER=$(ip r| grep 'default via'|awk '{print $3}')
  # TODO configure the above via playbook
  cat > /etc/apt/apt.conf <<EOF
Acquire::http::proxy "http://$FUSS_SERVER:8000";
Acquire::https::proxy "http://$FUSS_SERVER:8000";
EOF
  cd /root
  wget -O run_upgrade http://$FUSS_SERVER/fuss-data-conf/fcru/run_upgrade
  wget -O upgrade.yml http://$FUSS_SERVER/fuss-data-conf/fcru/upgrade.yml
  wget -O /etc/rc.local http://$FUSS_SERVER/fuss-data-conf/fcru/rc.local
  chmod +x /etc/rc.local /root/run_upgrade
  sed -i "s/1/0/g" /etc/apt/apt.conf.d/20auto-upgrades
  # Comment next line to avoid PC reboot
  systemctl reboot
fi

exit 0
